Multi-sig action
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "multiSig",
"signatureChainId": "0xa4b1",
"signatures": [
{
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
}
],
"payload": {
"multiSigUser": "0x1234567890abcdef1234567890abcdef12345678",
"outerSigner": "0xabcdef1234567890abcdef1234567890abcdef12",
"action": {
"type": "noop"
}
}
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "multiSig",
"signatureChainId": "0xa4b1",
"signatures": [
{
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
}
],
"payload": {
"multiSigUser": "0x1234567890abcdef1234567890abcdef12345678",
"outerSigner": "0xabcdef1234567890abcdef1234567890abcdef12",
"action": { "type": "noop" }
}
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'multiSig',
signatureChainId: '0xa4b1',
signatures: [
{
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
}
],
payload: {
multiSigUser: '0x1234567890abcdef1234567890abcdef12345678',
outerSigner: '0xabcdef1234567890abcdef1234567890abcdef12',
action: {type: 'noop'}
}
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
multiSig | Hyperliquid exchange
Submits or signs a multi-signature action for a multi-sig account. Used to propose or approve actions that require multiple signatures.
POST
/
exchange
Multi-sig action
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"multiSig"signatureChainId(string) — Chain ID for signaturepayload(object) — The action payload to sign
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "multiSig"},
"nonce": 1234567890123,
"signature": {...}
}'
# pip install hyperliquid-python-sdk eth-account
import time
import eth_account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
# The leader (outer signer) collects the inner signatures and submits the action.
leader = eth_account.Account.from_key("0xLEADER_PRIVATE_KEY")
exchange = Exchange(leader, constants.MAINNET_API_URL)
multi_sig_user = "0xMULTI_SIG_ACCOUNT_ADDRESS"
nonce = int(time.time() * 1000)
# inner_action is the action the multi-sig account performs (for example, an order).
inner_action = {"type": "scheduleCancel", "time": None}
# signatures collected from each authorized signer of the multi-sig account.
signatures = [
# sign_multi_sig_inner_action(...) output per signer
]
result = exchange.multi_sig(
multi_sig_user=multi_sig_user,
inner_action=inner_action,
signatures=signatures,
nonce=nonce,
)
print(result)
// npm install @nktkas/hyperliquid viem
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
const multiSigUser = "0xMULTI_SIG_ACCOUNT_ADDRESS"; // the multi-sig account address
const signers = [
privateKeyToAccount("0xLEADER_PRIVATE_KEY"), // leader — signs the wrapper
privateKeyToAccount("0xOTHER_SIGNER_PRIVATE_KEY"),
] as const;
const transport = new HttpTransport(); // public mainnet endpoint
const client = new ExchangeClient({ transport, signers, multiSigUser });
// The client wraps each action in a multiSig action automatically.
const result = await client.order({ orders: [/* ... */], grouping: "na" });
console.log(result);
Use case
- Multi-sig action — Submits or signs a multi-signature action for a multi-sig account. Used to propose or approve actions that require multiple signatures.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?
⌘I